
import java.awt.*;

/**
 * Write a description of class SolarizationFilter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SolarizationFilter extends Filter
{

    /**
     * Constructor for objects of class SolarizationFilter
     */
    public SolarizationFilter( String name )
    {
        super(name);
    }

    /**
     * Apply this filter to an image.
     * 
     * @param  image  The image to be changed by this filter.
     */
    public void apply(OFImage image)
    {
        int height = image.getHeight();
        int width = image.getWidth();
        for(int y = 0; y < height; y++) {
            for(int x = 0; x < width; x++) {
                Color pixel = image.getPixel(x, y);
                int red = pixel.getRed(), blue = pixel.getBlue(), green = pixel.getGreen();
                if ( red < 128 )
                    red = 255 - red;
                if ( green < 128 )
                    green = 255 - green;
                if ( blue < 128 )
                    blue = 255 - blue;
                image.setPixel(x, y, new Color( red, green, blue ) );
            }
        }
    }
}
